//  リスト13.3 音声を再生するアプレット
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.AudioClip;

public class SoundExample extends JApplet implements ActionListener{
   AudioClip clip;     // オーディオクリップ用の変数を宣言 
   boolean looped;     // 繰返再生中か否かのフラグ false:停止中 true:再生中
   JButton loopB, onceB, stopB;

   public void init(){
     Container c = getContentPane();
     c.setLayout(new FlowLayout());
     onceB = makeButton("1回再生", c);   // ボタンを置く
     loopB = makeButton("繰返再生", c);  // ボタンを置く 
     stopB = makeButton("繰返停止", c);  // ボタンを置く
     stopB.setEnabled(false);         // 停止ボタンを無効にする
     clip = getAudioClip(getCodeBase(), "whinny.au"); 
   }                   // 音声ファイルを指定してオーディオクリップを作る

   JButton makeButton(String str, Container c){  
     JButton b = new JButton(str);   //ボタンを作る
     b.addActionListener(this);      //リスナーを設定
     c.add(b);                       //ボタンをJAppletに追加
     return b;
   }

   public void stop(){    // ブラウザが別のWebページに移った時 
     if(looped){  clip.stop();  }
             // 繰返し再生中ならオーディオクリップの再生を中止する    
   }

   public void start(){   // アプレットを含むページが表示された時
     if(looped){  clip.loop();  }
             // 再生中だったならオーディオクリップの再生を再開する
   }

   public void actionPerformed(ActionEvent e){
     Object obj = e.getSource();
     if(obj == onceB){                //1回再生ボタンが押されたら
        clip.play();                  // オーディオクリップを再生する
        looped = false;               // 再生フラグをoffに設定
        loopB.setEnabled(true);       // 繰返ボタンを有効にする
        stopB.setEnabled(false);      // 停止ボタンを無効にする
        showStatus("Play sound once");   //ブラウザのステイタスラインに状態表示
     }
     else if(obj == loopB){    // 繰返再生ボタンが押されたら
        looped = true;         // 再生フラグをonに設定
        clip.loop();           // オーディオクリップを繰返し再生する
        loopB.setEnabled(false);      // 繰返ボタンを無効にする
        stopB.setEnabled(true);       // 停止ボタンを有効にする
        stopB.requestFocus();  //停止ボタンにキーボードフォーカスを移す
        showStatus("Play sound continuously"); 
     }
     else if (obj == stopB){  // 停止ボタンが押されたら
        looped = false;       // 再生フラグをoffに設定
        clip.stop();          // オーディオクリップの再生を中止する 
        loopB.setEnabled(true);       // 繰返ボタンを有効にする
        stopB.setEnabled(false);      // 停止ボタンを無効にする
        showStatus("Stopped sound");
     }
   }    
}
