//  リスト12.6 アダプターを使ったマウスリスナー
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class AdapterTest extends JPanel{
   int x1, y1, x2, y2;
   AdapterTest(){
      setBackground(Color.yellow);
      setMinimumSize(new Dimension(250, 250));  
      setPreferredSize(new Dimension(250, 250));
      addMouseListener(new MyMouse());            //マウスリスナーを設定
   }

   public void paintComponent(Graphics g){    
      super.paintComponent(g);
      g.drawLine(x1,y1,x2,y2);
   }

   class MyMouse extends MouseAdapter{ //内部リスナークラス
     public void mousePressed(MouseEvent e){ //マウスを押した時の処理
        x1 = e.getX();
        y1 = e.getY();
     }
     public void mouseReleased(MouseEvent e){ //マウスを離した時の処理
        x2 = e.getX();
        y2 = e.getY();
        repaint();     //ボタンを離した時、図形を描く
     }
   }

   public static void main(String args[]){
      AdapterTest h = new AdapterTest();  
      JFrame frame = new JFrame();
      Container c = frame.getContentPane(); 
      c.add(h, BorderLayout.CENTER);
      frame.pack();               
      frame.setVisible(true);     
   }
}


