// リスト12.4 独立したリスナークラス
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class HelloOut extends JPanel{
   JLabel label; //ラベル用の変数
   JButton b1, b2;//ボタン用の変数
   OutListener listener;
   HelloOut(){  
      label = new JLabel(" ");  //最初は何も表示しない
      b1 = new JButton("ごあいさつ");  //ごあいさつボタン
      b2 = new JButton("消去");  //消去ボタン

      listener = new OutListener(this);
      b1.addActionListener(listener); //イベントリスナーを設定
      b2.addActionListener(listener); //イベントリスナーを設定

      setLayout(new BorderLayout());   //配置方式の設定
      add(label, BorderLayout.NORTH);  //ラベルを置く
      add(b1, BorderLayout.CENTER);    //ボタンを置く
      add(b2, BorderLayout.EAST);      //ボタンを置く
   }

   public static void main(String args[]){
      HelloOut h = new HelloOut();  //HelloOutのオブジェクトを生成
      JFrame frame = new JFrame();//JFrameオブジェクトを生成
      Container c = frame.getContentPane(); //フレームの内容表示域を得る
      c.add(h, BorderLayout.CENTER);//フレームにHelloOutオブジェクトを置く
      frame.pack();               //フレームを必要最小の大きさにする
      frame.setVisible(true);     //フレームを画面に見せる
   }
}

class OutListener implements ActionListener{ //イベントリスナー
    HelloOut hello;
    public OutListener(HelloOut h){
       hello = h;
    }

    public void actionPerformed(ActionEvent e){
       if(e.getSource() == hello.b1){            //b1が押されたら
          hello.label.setText("こんちには");     //labelに文字列を設定 
       }else if(e.getSource() == hello.b2){      //b2が押されたら
          hello.label.setText(" ");              //labelの文字列を消す
       }
    }
}
    
