// リスト12.2 肥満度計算プログラム
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class Himando extends JPanel implements ActionListener{
  Person hito;               //人オブジェクト用変数
  JTextField hField,wField;   //入力フィールド用変数
  JLabel hyoujun,hantei,himando;      //ラベル用変数

  Himando(){
     setBackground(Color.white);
     hField = new JTextField(10);  //入力フィールドを生成
     wField = new JTextField(10);
     hyoujun = new JLabel();       //ラベルを生成
     hantei= new JLabel();
     himando= new JLabel();
     hField.addActionListener(this);  //入力フィールドにリスナーを設定
     wField.addActionListener(this);
     setLayout(new GridLayout(4,2));  //レイアウトを設定
     add(new JLabel("身長(cm)"));      //パネルに部品を配置
     add(hField);                     
     add(new JLabel("体重(Kg)"));
     add(wField);
     add(new JLabel("標準体重(Kg)"));
     add(hyoujun);
     add(new JLabel("肥満度(%)"));
     add(himando);
  
     hito = new Person();          //人オブジェクト生成
  }

  //入力フィールドでreturnキーが押された時、実行されるメソッド
  public void actionPerformed(ActionEvent e){  
     float f;
     try{
        f = Float.parseFloat(hField.getText());
     } catch (NumberFormatException error){ f = 0.0F; }
     hito.setHeight(f);    //身長を設定

     try{
        f=Float.parseFloat(wField.getText());
     } catch (NumberFormatException error){ f = 0.0F; }
     hito.setWeight(f);   //体重を設定

     doCalc();        
   }

  void doCalc(){
     if(hito.getHeight() <= 0) { hField.requestFocus(); }
     else if(hito.getWeight() <= 0) { wField.requestFocus(); }
     else {
        hyoujun.setText(Float.toString(hito.calcStdWeight()));//標準体重を表示
        himando.setText(Float.toString(hito.calcHimando()*100));  //肥満度を表示
     }
  }

  public static void main(String args[]) {
     JFrame f = new JFrame("Himando");
     Himando h = new Himando();        //肥満度パネルを作る
     Container c = f.getContentPane(); 
     c.add(h, BorderLayout.CENTER);
     f.pack();                        
     f.setVisible(true);
  }
}

class Person{   //人クラス
   private float weight;  //体重を格納する変数
   private float height;  //身長を格納する変数

   float getWeight() { return weight; }  //体重を返すメソッド
   float getHeight() { return height; }  //身長を返すメソッド
   void setWeight(float w) { weight = w; }  //体重を設定するメソッド
   void setHeight(float h) { height = h; }  //身長を設定するメソッド

   float calcStdWeight(){ //標準体重を計算
      return (height-100)*0.9F;
   }

   float calcHimando(){  //肥満度を計算
      float std = calcStdWeight();
      return (weight-std)/std;
   }
}
