// リスト11.3 木のフラクタル
import java.awt.*; 
import javax.swing.*;  

class Tree extends JPanel{
    double scale;      // 育つ枝の比率 
    int angle;          // 枝の広がる角度 
    int n;               // 繰り返し回数 
    double stand,len;    // 最初の枝の方向、枝の長さ 
    int w,h; 
    final double RAD=Math.PI/180.0;  // ラジアンに変換するための値

    Tree() {   // 初期化メソッド 
       scale=0.7;      // 育つ枝の比率 
       angle=30;       // 枝の広がる角度 
       n=8;            // 繰り返し回数 
       stand=90;
       len=100;    // 最初の枝の長さ 
    }   

    public void paintComponent(Graphics g) { 
       w=getSize().width;               // 幅
       h=getSize().height;              // 高さ
       g.setColor(Color.white);  // 背景色 
       g.fillRect(0,0,w,h);            // 背景 
       g.setColor(new Color(100, 153, 0));  // 色の設定 
       drawTree(g,n,w/2,0,len,stand);        // 木を描く 
    }
    
    //木を再帰的に描く
    public void drawTree(Graphics g, int nn, double x1, double y1, 
                                                double len,double stand){ 
       double x2,y2; 
       x2=len*Math.cos(RAD*stand)+x1;            //枝先のx座標
       y2=len*Math.sin(RAD*stand)+y1;            //枝先のy座標
       g.drawLine((int)x1,(int)(h-y1),(int)x2,(int)(h-y2)); 

       if(nn>1){
       drawTree(g,nn-1,x2,y2,len*scale,stand-angle); //次の右の枝 
       drawTree(g,nn-1,x2,y2,len*scale,stand+angle); //次の左の枝 
       }
     } 

    public static void main(String args[]){
       JFrame f  = new JFrame("Tree Example");
       Tree example = new Tree();
       f.getContentPane().add(example, BorderLayout.CENTER);
       f.setSize(350, 350);
       f.setVisible(true);
    }
}  



