import java.awt.Color;

public class Stepper extends Turtle{
  public int n;               //インスタンス変数 n の宣言
  public int size;      //インスタンス変数 size の宣言
  private int j = 0;              //（内部）インスタンス変数 j の宣言
  public static final int ALREADY_FIN = 0;
  public static final int JUST_FIN = 1;
  public static final int  NOT_FIN = 2;

  /** x, y という座標に angle の角度の Stepper を生成 */
  Stepper(int x, int y, int angle, int n, int size)
    {
      super(x, y, angle);    //Turtle のコンストラクタ呼び出し
      this.n = n;            //インスタンス変数 n に 引数 n を設定
      this.size = size;      //インスタンス変数 size の設定
    }

  /** n = 4, size = 100 の Stepper を作成 */
  Stepper(int x, int y, int angle)
    {
      this(x, y, angle, 4, 100); //上記のコンストラクタ呼び出し
    }

  /** 0 引数のコンストラクタ */
  Stepper() {   super();}    //上位コンストラクタを呼び出すだけ
  
  public int step()
  {
    if(j >= n)
        return ALREADY_FIN;         //描き終えていたならすぐ終了
    fd(size);
    rt(360/n);
    if(++j == n)       //jを1増やすことと n と比較することを1つの式で行う
        return JUST_FIN;  
    return NOT_FIN;                  //ここに来るのは，2つの if の条件を満たさないとき
  }
  public void reset() { j = 0; }

  public static void main(String[] args){
    TurtleFrame f = new TurtleFrame(600,300);
    int[] size = {100,28,90,40,2,100,40,2, 30, 20};
    int[] n = {6, 5, 3,10,20,3,4,5,3,5};
    Color[] c = {Color.black, Color.blue, Color.cyan, Color.darkGray};
    Stepper[] hm = new Stepper[10];
    for(int i = 0 ; i < 10; i++){
      hm[i] = new Stepper(i * 50 + 25,150,0, n[i], size[i]);
      hm[i].setColor(c[i % c.length]);
      f.add(hm[i]);
    }
    for(int j = 0; j < 20; j++){
      for(int i = 0; i < 10; i++){
	hm[i].step();
      }
    }
  }

}
