
#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>

using std::cout;
using std::endl;
using std::next_permutation;

// 5つの(sortされた)数を受け取って、
// 全加算のパターンを計算する
void calc_set(int pfivenums[]) {
  while(next_permutation(pfivenums, pfivenums+5)) {
    int ringfivenums[9] = {
      pfivenums[0],
      pfivenums[1],
      pfivenums[2],
      pfivenums[3],
      pfivenums[4],
      pfivenums[0],
      pfivenums[1],
      pfivenums[2],
      pfivenums[3],
    };
    int checklist = 0;
    int sum;
    for(int i = 0; i < 5; ++i) {
      sum = -1;
      int jmax = i + 4;
      for(int j = i; j < jmax; ++j) {
	sum += ringfivenums[j];
	checklist |= 1 << sum;
      }
    }
    sum += ringfivenums[3]; // sum == 5つの数の和
    checklist |= 1 << sum;

    if(checklist == 0x1FFFFF) {
      for(int i = 0; i < 5; ++i) {
	cout << pfivenums[i] << ' ';
      }
      cout << endl;
    }
  }
}

// 10個の中から5個選び続ける
// ビバ5重ループ
void choose() {
  int i[5];
  for(i[0] = 1; i[0] <= 10; ++(i[0])) {
    for(i[1] = i[0]+1; i[1] <= 10; ++(i[1])) {
      for(i[2] = i[1]+1; i[2] <= 10; ++(i[2])) {
	for(i[3] = i[2]+1; i[3] <= 10; ++(i[3])) {
	  for(i[4] = i[3]+1; i[4] <= 10; ++(i[4])) {
	    calc_set(i);
	  } 
	} 
      } 
    } 
  }
}

int main() {
  choose();
  return 0; 
}

